package journal.action;

import journal.reader.DataJournalEntry;
import journal.reader.DeleteJournalEntry;
import journal.reader.NoteJournalEntry;
import journal.reader.Options;
import journal.reader.TransactionJournalEntry;

// Visitor interface
// Implemented by whoever wants to be called with the correct action 
// Depending on the token

public interface Action {
	public void help();
	public void start() throws Exception;
	public void setDefaultOptions(Options options);
	
	public void finish() throws Exception;
	public String[] parseArgs(String[] args);
	
	public void putValue(DataJournalEntry entry) throws Exception;
	public void replaceValue(DataJournalEntry entry) throws Exception;
	public void deleteValue(DataJournalEntry entry) throws Exception;
	public void verifyValue(DataJournalEntry entry) throws Exception;
	public void commitMarker(TransactionJournalEntry entry) throws Exception;
	public void flushMarker(TransactionJournalEntry entry) throws Exception;
	public void journalMarker(NoteJournalEntry entry) throws Exception;
	public void deleteMarker(DeleteJournalEntry entry) throws Exception;
}
