package journal.action;

import java.util.ArrayList;
import java.util.List;

import jargs.gnu.CmdLineParser;

import journal.schema.TableVersion;

public class FilepathRenamer extends BaseRenamerAction 
{	
	public FilepathRenamer() {
		super("FilepathRenamer");
	}
	

	@Override
	public void start() throws Exception {
		super.start();
	}
	
	@Override
	public void help() {
		System.err.println("\t--action journal.action.FilepathRenamer -- <options>");
		System.err.println("\t\tOptions are\n");
		super.help();
	}
	
	@Override
	public void finish() throws Exception  {
		super.finish();
	}

	@Override
	void addArgs(CmdLineParser parser) {
		// no args at the moment
	}


	@Override
	void processArgs(CmdLineParser parser) {
		// therefore nothing to process
	}


	@Override
	RenameAction getAction(TableVersion version) {
		if( !actionMap.containsKey(version)) {
			RenameAction action = EmptyAction.instance;
			
			List<RenameAction> list = new ArrayList<RenameAction>();

			if( version.getAttributeByName("dfile") != null ) {
				list.add( new FileRenameAction("dfile") );
			}
			if( version.getAttributeByName("tfile") != null ) {
				list.add( new FileRenameAction("tfile") );
			}
			if( version.getAttributeByName("ffile") != null ) {
				list.add( new FileRenameAction("ffile") );
			}
			if( version.getAttributeByName("afile") != null ) {
				list.add( new FileRenameAction("afile") );
			}
			
			// need to add traits for P4Bucket
			// need to test archive !
			
			if( list.size() == 1 ) {
				action = list.get(0);
			}
			else if ( list.size() > 1 ) {
				action = new CompoundActions(list);
			}
			
			actionMap.put(version, action);
		}
		
		return actionMap.get(version);
	}
	
}
